package test.web.jparl;

import org.testng.annotations.Configuration;
import org.testng.annotations.ExpectedExceptions;
import org.testng.annotations.Test;
import org.testng.annotations.*;
import org.testng.Assert;

import java.io.*;
import java.net.*;
import java.util.*;

public class WebTestNG {

    private static final String TEST_NAME =
        "jparlds-noinjection";

    private static final String EXPECTED_RESPONSE_JSP =
        "JPA Example";

    private static final String EXPECTED_RESPONSE_SERVLET =
        "JpaTest:PASSED";
    
    private String strContextRoot="jparlds";

    static String result = "";
    String host=System.getProperty("http.host");
    String port=System.getProperty("http.port");

    @Test(groups ={ "pulse"} ) // test method
    public void simpleJSPTestPage() throws Exception{
        
        try{
         

        String testurl = "http://" + host  + ":" + port + "/"+ strContextRoot + "/index.jsp";
        System.out.println("URL is: "+testurl);
        URL url = new URL(testurl);
        echo("Connecting to: " + url.toString());
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.connect();
        int responseCode = conn.getResponseCode();

        Assert.assertEquals(responseCode, 200);

        InputStream is = conn.getInputStream();
        BufferedReader input = new BufferedReader(new InputStreamReader(is));

        String line = null;
        boolean result=false;
        String testLine = null;        
        while ((line = input.readLine()) != null) {
            if(line.indexOf(EXPECTED_RESPONSE_JSP)!=-1){
                result=true;
                testLine = line;
                echo(testLine);
                break;
            }
        }        
                
        Assert.assertEquals(result, true,"Unexpected Result");
        
        }catch(Exception e){
            e.printStackTrace();
            throw new Exception(e);
        }

    }
           
    @Test(groups ={ "pulse"} ) // test method
    public void simpleServletTest() throws Exception{
         try{
         

        String testurl = "http://" + host  + ":" + port + "/"+ strContextRoot + "/jpa";
        System.out.println("URL is: "+testurl);
        URL url = new URL(testurl);
        echo("Connecting to: " + url.toString());
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.connect();
        int responseCode = conn.getResponseCode();


        InputStream is = conn.getInputStream();
        BufferedReader input = new BufferedReader(new InputStreamReader(is));

        String line = null;
        boolean result=false;
        String testLine = null;        
        while ((line = input.readLine()) != null) {
            if(line.indexOf(EXPECTED_RESPONSE_SERVLET)!=-1){
	      result=true;
	      testLine = line;
	      echo(testLine);
	      break;
            }
          
        }        
                
        Assert.assertEquals(result, true, "Unexpected Results");
               
        
        }catch(Exception e){
            e.printStackTrace();
            throw new Exception(e);
        }
        
    }

    public static void echo(String msg) {
        System.out.println(msg);
    }

}
